/* RVM++: Relevance Vector Machine in C++
 *
 * Copyright (C) 2008 XIAO Jianxiong
 *
 * http://www.cse.ust.hk/~csxjx/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef RVMCLASSIFIER_H
#define RVMCLASSIFIER_H

#include "RVMmachine.h"

namespace RVM
{
	class RVMclassifier:public RVMmachine
	{
	public:
		RVMclassifier();
		RVMclassifier(RVMdataset* _training,RVMkernel* _kernel,
			unsigned int _maxIts,bool _withBias,double _initAlpha);
		virtual void estimate(RVMmatrix const & PHI,RVMmatrix const & t, 
			RVMmatrix const & alpha, RVMmatrix & w, RVMmatrix & Ui, double & betaED, 
			double & logBeta, double beta, unsigned int ptNum,double& ED);
		virtual void predictPoint(RVMpoint* curPt);
	};
}

#endif
