/* RVM++: Relevance Vector Machine in C++
 *
 * Copyright (C) 2008 XIAO Jianxiong
 *
 * http://www.cse.ust.hk/~csxjx/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "RVMpoint.h"

template<class T>
inline void SWAP(T &a, T &b)
	{T dum=a; a=b; b=dum;}

namespace RVM
{
double sigmoid	(double x);
double Kgauss	(const RVMpoint*, const RVMpoint*, double lenscal);	//Gaussian
double Klaplace	(const RVMpoint*, const RVMpoint*, double lenscal);	//Laplacian
double Kpoly	(const RVMpoint*, const RVMpoint*, double lenscal);	//Polynomial
double Khpoly	(const RVMpoint*, const RVMpoint*, double lenscal);	//Homogeneous Polynomial
double Kcauchy	(const RVMpoint*, const RVMpoint*, double lenscal);	//Cauchy (heavy tailed) in distance
double Kcubic	(const RVMpoint*, const RVMpoint*, double lenscal);	//Cube of distance
double Kr		(const RVMpoint*, const RVMpoint*, double lenscal);	//Distance
double Ktps		(const RVMpoint*, const RVMpoint*, double lenscal);	//'Thin-plate' spline
double Kbubble	(const RVMpoint*, const RVMpoint*, double lenscal);	//Neighbourhood indicator

}
